//#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("sse", "sse2", "sse3", "ssse3", "sse4")

#include <bits/stdc++.h>

#define all(a) a.begin(),a.end()
#define len(a) (int)(a.size())
#define mp make_pair
#define pb push_back
#define fir first
#define sec second
#define fi first
#define se second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<typename T>
bool umin(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
bool umax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

#ifdef KIVI
#define DEBUG for (bool _FLAG = true; _FLAG; _FLAG = false)
#define LOG(...) print(#__VA_ARGS__" ::", __VA_ARGS__) << endl
template <class ...Ts> auto &print(Ts ...ts) { return ((cerr << ts << " "), ...); }
#else
#define DEBUG while (false)
#define LOG(...)
#endif

const int max_n = 1e6 + 11, inf = 1000111222;

int cur_time = 0;

struct dsu {
public:
    int n;
    vector <int> p, cnt, c, t;

    inline void make_set (int v) {
        p[v] = v;
    }

    dsu (int n) : n(n) {
        p.resize(n);
        cnt.assign(n, 1);
        c.resize(n);
        t.resize(n);
        for (int i = 0; i < n; i++) {
            make_set(i);
        }
    }

    inline void upd (int v) {
        if (t[v] != cur_time) {
            t[v] = cur_time;
            p[v] = v;
            cnt[v] = 1;
            c[v] = 0;
        }
    }

    inline pii get (int v) {
        if (v != p[v]) {
            int cc = c[v];
            tie(p[v], c[v]) = get(p[v]);
            c[v] ^= cc;
        }
        return {p[v], c[v]};
    }

    inline bool unite(int a, int b) {
        upd(a);
        upd(b);
        int c1, c2;
        tie(a, c1) = get(a);
        tie(b, c2) = get(b);
        if (a == b) {
            if (c1 == c2) {
                return false;
            }
            return true;
        }
        if (cnt[a] < cnt[b]) {
            swap(a, b);
        }
        p[b] = a;
        c[b] = c1 ^ c2 ^ 1;
        cnt[a] += cnt[b];
        return true;
    }
};

vector <int> edge[max_n];
int color[max_n];

int timer = 0, used[max_n];

inline bool dfs (int v, int c) {
    used[v] = timer;
    color[v] = c;
    for (int to : edge[v]) {
        if (used[to] != timer) {
            if (!dfs(to, c ^ 1)) {
                return false;
            }
        }
        if (color[to] != (c ^ 1)) {
            return false;
        }
    }
    return true;
}

inline bool bad (int n) {
    ++timer;
    for (int j = 0; j < n; j++) {
        if (used[j] != timer) {
            if (!dfs(j, 0)) {
                return true;
            }
        }
    }
    return false;
}


int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector <int> dp(m + 1, inf);
    dp[0] = 0;
    vector <pii> e(m);
    for (auto &i : e) {
        cin >> i.first >> i.second;
        --i.first, --i.second;
    }
    for (int i = 0; i < m; i++) {
        ++cur_time;
        for (int j = i; j < m; j++) {
            edge[e[j].first].pb(e[j].second);
            edge[e[j].second].pb(e[j].first);
            if (bad(n)) {
                break;
            }
            if (umin(dp[j + 1], dp[i] + 1)) {
//                LOG(j + 1, i, dp[i] + 1);
            }
        }
        for (int j = 0; j < n; j++) {
            edge[j].clear();
        }
    }
    for (auto &i : dp) LOG(i);
    cout << dp[m] << '\n';
}