#include <iostream>
#include <algorithm>
#include <iomanip>
#include <random>
#include <string.h>
 
using namespace std;
 
constexpr int N = (int)1e6+111;
constexpr long long L = (long long)1e18;
 
struct node{
    node* l;
    node* r;
    int mx;
    node():l(nullptr),r(nullptr),mx(0){}
};
 
inline int value(node* v){
    return v ? v->mx : 0;
}
 
void upd(node* v,long long l,long long r,long long pos,int val){
    if(l == r){
        v->mx = max(v->mx,val);
        return;
    }
    long long m = (l+r)/2;
    if(pos <= m){
        if(!v->l)
            v->l = new node();
        upd(v->l,l,m,pos,val);
    } else {
        if(!v->r)
            v->r = new node();
        upd(v->r,m+1,r,pos,val);
    }
    v->mx = max(value(v->l),value(v->r));
    return;
}
 
int get(node* v,long long l,long long r,long long tl,long long tr){
    if(l > r || tl > tr || !v)
        return 0;
    if(l == tl && r == tr)
        return value(v);
    long long m = (l+r)>>1;
    return max(get(v->l,l,m,tl,min(tr,m)),get(v->r,m+1,r,max(tl,m+1),tr));
}
 
int main(){
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    
    int n;
    long long l,r;
    cin >> n >> l >> r;
 
    node* rt = new node();
 
    for(int i = 0; i < n; i++){
        long long a;
        cin >> a;
        int mx = get(rt,0,L,l-a+r,r-a+r);
        upd(rt,0,L,a+r,mx+1);
    }
 
    cout << value(rt) << "\n";
 
    return 0;
}
