//#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("sse", "sse2", "sse3", "ssse3", "sse4")

#include <bits/stdc++.h>

#define all(a) a.begin(),a.end()
#define len(a) (int)(a.size())
#define mp make_pair
#define pb push_back
#define fir first
#define sec second
#define fi first
#define se second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<typename T>
bool umin(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
bool umax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

#ifdef KIVI
#define DEBUG for (bool _FLAG = true; _FLAG; _FLAG = false)
#define LOG(...) print(#__VA_ARGS__" ::", __VA_ARGS__) << endl
template <class ...Ts> auto &print(Ts ...ts) { return ((cerr << ts << " "), ...); }
#else
#define DEBUG while (false)
#define LOG(...)
#endif

const int max_n = -1, inf = 1000111222;

struct node {

    int mx;

    /// not existing node
    node () : mx(0) {}

    node (int x) : mx(x) {

    }
};



inline node pull (node a, node b) {
    return node(max(a.mx, b.mx));
}

struct segment_tree {
    vector <node> t;
    int n;

    segment_tree () {}

    inline void build (int v, int tl, int tr) {
        if (tl == tr) {
            t[v] = node(); /// think
            return;
        }
        int tm = (tl + tr) >> 1;
        build(v << 1, tl, tm);
        build(v << 1 | 1, tm + 1, tr);
        t[v] = pull(t[v << 1], t[v << 1 | 1]);
    }

    segment_tree (int n) : n(n) {
        t.resize(4 * n);
        build(1, 0, n - 1);
    }

    inline void push (int v, int tl, int tr) {

    }

    inline void update (int v, int tl, int tr, int l, int r, int x) { /// think
        push(v, tl, tr);
        if (l > r) return;
        if (tl == l && tr == r) { /// think
            // t[v]
            push(v, tl, tr);
            return;
        }
        int tm = (tl + tr) >> 1;
        update(v << 1, tl, tm, l, min(r, tm), x);
        update(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r, x);
        t[v] = pull(t[v << 1], t[v << 1 | 1]);
    }

    inline void update1 (int v, int tl, int tr, int pos, int x) { /// think
        push(v, tl, tr);
        if (tl == tr) {
            t[v] = x;
            return;
        }
        int tm = (tl + tr) >> 1;
        if (pos <= tm) {
            update1(v << 1, tl, tm, pos, x);
        }
        else {
            update1(v << 1 | 1, tm + 1, tr, pos, x);
        }
        t[v] = pull(t[v << 1], t[v << 1 | 1]);
    }

    inline node query (int v, int tl, int tr, int l, int r) {
        push(v, tl, tr);
        if (l > r) return node();
        if (tl == l && tr == r) {
            return t[v];
        }
        int tm = (tl + tr) >> 1;
        return pull(query(v << 1, tl, tm, l, min(r, tm)), query(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r));
    }

    inline void upd (int l, int r, int x) {
        update(1, 0, n - 1, l, r, x);
    }

    inline void upd1 (int pos, int x) {
        update1(1, 0, n - 1, pos, x);
    }

    inline node get (int l, int r) {
        return query(1, 0, n - 1, l, r);
    }
};

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    ll l, r;
    cin >> n >> l >> r;
    vector <ll> c(3 * n);
    vector <ll> a(n);
    for (int i = 0, num = 0; i < n; i++) {
        cin >> a[i];
        c[num++] = a[i];
        c[num++] = r - a[i];
        c[num++] = l - a[i];
    }
    sort(all(c));
    c.erase(unique(all(c)), c.end());
    int m = len(c);
    segment_tree t(m);
    for (int i = 0; i < n; i++) {
        int L = lower_bound(all(c), l - a[i]) - c.begin();
        int R = lower_bound(all(c), r - a[i]) - c.begin();
        int pos = lower_bound(all(c), a[i]) - c.begin();
        int dp = t.get(L, R).mx + 1;
        t.upd1(pos, dp);
    }
    cout << t.get(0, m - 1).mx << '\n';
}